comment		*

Algorithm		: UUcoding Unit ( UUEncode & UUDecode )

Abstact		: A set of algorithms for converting files into a series of 7-bit ASCII characters that can be transmitted over the Internet. 
		  Originally, uuencode stood for Unix-to-Unix encode, but it has since become a universal protocol used to transfer files between 
		  different platforms such as Unix, Windows, and Macintosh. Uuencoding is especially popular for sending e-mail attachments. 
		  Nearly all e-mail applications support uuencoding for sending attachments and uudecoding for receiving attachments

Usage		: invoke	UUEncode,addr ptrIndata,ptrIndata_length,addr ptrOutdata	( Encode )  
		  invoke	UUDecode_Verify,addr ptrIndata				( Decode string Format Check )	
		  invoke	UUDecode,addr ptrIndata,ptrIndata_length,addr ptrOutdata	( Decode )
		  		  
Coded by x3chun	( 2004.05.12)
		( x3chun@korea.com  or  x3chun@hanyang.ac.kr ) ( http://x3chun.wo.to )
		
comment		*

UUEncode		proto	:DWORD,:DWORD,:DWORD
UUDecode	proto	:DWORD,:DWORD,:DWORD
UUDecode_Verify	proto	:DWORD

.data

UUdecode_v_string		db	"Incorrect String Format!",0		; Just For testing!
_error			db	"error",0

.code

UUEncode		proc	ptrIndata:DWORD, ptrIndata_length:DWORD, ptrOutdata:DWORD
	
		pushad
		xor	ebx,ebx		
		mov	esi,[esp+28h]	; ptrIndata
		mov	edi,[esp+30h]	; ptrOutdata
		mov	eax,[esp+2ch]	; ptrIndata_length
		cmp	eax,0
		jz	@_err
		add	eax,20h
		mov	[edi],al
		sub	al,20h
		mov	ebp,eax
		mov	ecx,3
		cdq
		idiv	ecx
		test	edx,edx
		jz	@_OK
		sub	ecx,edx
		lea	edi,[esi+ebp]
		lea	esi,[esi+ebp]
		sub	esi,ecx
		.if	ecx==1
		sub	esi,2
		.elseif
		dec	esi
		.endif
		rep	movsb
@_OK:
		mov	esi,[esp+28h]	; ptrIndata
		mov	edi,[esp+30h]	; ptrOutdata
		mov	eax,ebp	
		add	eax,2
		mov	ecx,3
		cdq
		idiv	ecx
		mov	ecx,eax
		xor	ebp,ebp
@_loop:		
		mov	al,[esi+ebx]
		mov	ah,al
		and	al,0FCh
		shr	al,2
		add	al,32
		cmp	al,32
		jnz	@_r1
		mov	byte ptr [edi+ebp+1],96
@_r1:
		mov	[edi+ebp+1],al
		and	ah,03h
		shl	ah,4
		mov	al,[esi+ebx+1]
		mov	dl,al
		and	al,0F0h
		shr	al,4
		or	al,ah
		add	al,32
		cmp	al,32
		jnz	@_r2
		mov	byte ptr [edi+ebp+2],96
@_r2:
		mov	[edi+ebp+2],al
		and	dl,0Fh
		shl	dl,2
		mov	dh,[esi+ebx+2]
		mov	al,dh
		and	dh,0C0h
		shr	dh,6
		or	dl,dh
		add	dl,32
		cmp	dl,32
		jnz	@_r3
		mov	byte ptr [edi+ebp+3],96
@_r3:
		mov	[edi+ebp+3],dl
		and	al,3Fh
		add	al,32
		cmp	al,32
		jnz	@_r4
		mov	byte ptr [edi+ebp+4],96
@_r4:
		mov	[edi+ebp+4],al
		add	ebx,3
		add	ebp,4
		dec	ecx
		jnz	@_loop	
@_err:
		popad
		ret
		
UUEncode		endp

UUDecode	proc	ptrIndata:DWORD, ptrIndata_length:DWORD, ptrOutdata:DWORD

		pushad
		xor	ebx,ebx
		xor	ebp,ebp
		mov	esi,[esp+28h]	; ptrIndata
		mov	edi,[esp+30h]	; ptrOutdata
		mov	ecx,[esp+2ch]	; ptrIndata_length
		cmp	ecx,0
		jz	@_err
		add	ecx,2
		sar	ecx,2
@_loop:	
		cmp	byte ptr [esi+ebp+1],96
		jnz	@_r1
		mov	byte ptr [esi+ebp+1],0
		jmp	@_next
@_r1:
		sub	byte ptr [esi+ebp+1],32
@_next:
		cmp	byte ptr [esi+ebp+2],96
		jnz	@_r2
		mov	byte ptr [esi+ebp+2],0
		jmp	@_next1
@_r2:
		sub	byte ptr [esi+ebp+2],32
@_next1:
		cmp	byte ptr [esi+ebp+3],96
		jnz	@_r3
		mov	byte ptr [esi+ebp+3],0
		jmp	@_next2
@_r3:
		sub	byte ptr [esi+ebp+3],32
@_next2:
		cmp	byte ptr [esi+ebp+4],96
		jnz	@_r4
		mov	byte ptr [esi+ebp+4],0
		jmp	@_next3
@_r4:
		sub	byte ptr [esi+ebp+4],32
@_next3:
		mov	al,[esi+ebp+1]
		mov	ah,[esi+ebp+2]
		mov	dl,ah
		shl	al,2
		shr	ah,4
		and	ah,03h
		or	al,ah
		mov	[edi+ebx],al
		mov	dh,[esi+ebp+3]
		mov	al,dh
		shr	dh,2
		and	dh,0Fh
		shl	dl,4
		or	dl,dh
		mov	[edi+ebx+1],dl
		mov	ah,[esi+ebp+4]
		and	ah,3Fh
		shl	al,6
		or	al,ah
		mov	[edi+ebx+2],al
		add	ebp,4
		add	ebx,3
		dec	ecx
		jnz	@_loop
		mov	cl,[esi]
		sub	cl,20h
		mov	byte ptr [edi+ecx],0
@_err:
		popad
		ret
		
UUDecode	endp


; ( If you wanna check valid UUDecode string , you use this proc. and you can change err msg , you decided! )
 
UUDecode_Verify	proc	ptrIndata:DWORD

		pushad
		mov	esi,[esp+28h]
		.if	byte ptr [esi]<33 || byte ptr [esi]>97
		invoke	MessageBox,0,addr UUdecode_v_string,addr _error,MB_ICONINFORMATION	; Just for testing
		.endif	
		popad
		ret
		
UUDecode_Verify	endp